/*
 * max5443.c
 *
 * Created: 06/04/2012 7:29:47 PM
 *  Author: mdryden
 */ 

#include <max5443.h>
// #include <main.h>
// #include <math.h>
// #include <asf.h>

// struct spi_device spi_device_conf_c = {
//           .id = IOPORT_CREATE_PIN(PORTC, 4)
//       };

struct usart_spi_device spi_device_conf_c = {
          .id = IOPORT_CREATE_PIN(PORTC, 4)
      };

void max5443_init_pins(void){
	ioport_configure_port_pin(&PORTC, PIN4_bm, IOPORT_INIT_HIGH | IOPORT_DIR_OUTPUT);
	ioport_configure_port_pin(&PORTC, PIN5_bm, IOPORT_INIT_HIGH | IOPORT_DIR_OUTPUT);
	ioport_configure_port_pin(&PORTC, PIN7_bm, IOPORT_INIT_HIGH | IOPORT_DIR_OUTPUT); 
//	ioport_configure_port_pin(&PORTC, PIN3_bm, IOPORT_INIT_LOW | IOPORT_DIR_OUTPUT); //CLR
// 	delay_us(1);
// 	ioport_configure_port_pin(&PORTC, PIN3_bm, IOPORT_INIT_HIGH | IOPORT_DIR_OUTPUT);
}

void max5443_init_module(void){
//       spi_master_init(&SPIC);
//       spi_master_setup_device(&SPIC, &spi_device_conf_c, SPI_MODE_0, 24000000UL, 0);
//       spi_enable(&SPIC);

	usart_spi_init(&USARTC1);
	usart_spi_setup_device(&USARTC1, &spi_device_conf_c, SPI_MODE_0, 24000000UL, 0);
//	usart_spi_enable(&USARTC1);
}
   
void max5443_set_voltage1(uint16_t dacindex){
/*	char logstr[10];*/

	static union{
		uint8_t ui8[2];
		uint16_t ui16;
	} buffer;
		
	if (buffer.ui16 == dacindex)
		return;
		
	buffer.ui16 = dacindex;
	
 	irqflags_t flags;
     flags = cpu_irq_save();
	
// 	spi_select_device(&SPIC, &spi_device_conf_c);
// 	spi_write_single(&SPIC, buffer.ui8[1]);
// 	delay_cycles(40);
// 	spi_write_single(&SPIC, buffer.ui8[0]);
// 	spi_deselect_device(&SPIC, &spi_device_conf_c);

	usart_spi_select_device(&USARTC1, &spi_device_conf_c);
	usart_spi_write_single(&USARTC1, buffer.ui8[1]);
	delay_cycles(40);
	usart_spi_write_single(&USARTC1, buffer.ui8[0]);
	usart_spi_deselect_device(&USARTC1, &spi_device_conf_c);
	
	cpu_irq_restore(flags);
	return;
}

// void max5443_set_voltage_8bit(uint8_t dacindex){
// 	spi_select_device(&SPIC, &spi_device_conf_c);
// 	spi_write_single(&SPIC, dacindex);
// 	spi_deselect_device(&SPIC, &spi_device_conf_c);
// 	return;
// }

/*void max5443_set_voltage(uint8_t msb, uint8_t lsb){
	irqflags_t flags;
    flags = cpu_irq_save();
	
	spi_select_device(&SPIC, &spi_device_conf_c);
	spi_write_single(&SPIC, msb);
	spi_write_single(&SPIC, lsb);
	spi_deselect_device(&SPIC, &spi_device_conf_c);
	
	cpu_irq_restore(flags);
}*/